<?php

use Illuminate\Database\Capsule\Manager as DB;

add_hook('DailyCronJob', 1, 'updateADModule');
add_hook('AdminAreaFooterOutput', 1, 'alertUserCannotUpdateADModule');

function alertUserCannotUpdateADModule($vars) {
    if ($vars['filename'] == 'clientsdomains') {
        $id = $_GET['id'];
        $userID = $_GET['userid'];
        if (!$id) {
            $domain = DB::table('tbldomains')->where('userid', '=', $userID)->orderBy('id', 'desc')->first();
        } else {
            $domain = DB::table('tbldomains')->where('id', '=', $id)->first();
        }
        if ($domain->registrar == 'affordabledomains') {
            if (!is_writable(__DIR__) || !is_writable(__DIR__ . '/../')) {
                $msg = "The <strong>Affordable Domains</strong> registrar module could not be automatically updated due to invalid folder permissions.<br />";
                $msg .= "Please make sure the following folders are writeable by <strong>'" . $_SERVER["USER"] . "'</strong><br /><br />";
                $msg .= '<ul style=\"margin: 0\">';
                if (!is_writable(__DIR__ . '/../')) {
                    $msg .= '    <li>' . str_replace('/affordabledomains', '', __DIR__) . '</li>';
                }
                if (!is_writable(__DIR__)) {
                    $msg .= '    <li>' . __DIR__ . '</li>';
                }
                $msg .= '</ul>';
            }

            if (!class_exists('ZipArchive')) {
                if ($msg) {
                    $msg .= "<br />";
                }
                $msg .= "Please install the <strong>'ZipArchive'</strong> php extention in order to automatically update the <strong>Affordable Domains</strong> registrar module.<br />";
            }

            if ($msg) {
                $return = '<style>.global-admin-warning li { list-style-type: none; } </style>' . "\n";
                $return .= '<script>' . "\n";
                $return .= '    $(".global-admin-warning").removeClass("hidden").html("' . $msg . '")' . "\n";
                $return .= '</script>' . "\n";

                return $return;
            }
        }
    }
    if (isset($_SESSION['ADJS'])) {
        session_start();
        $ADJS = $_SESSION['ADJS'];
        unset($_SESSION['ADJS']);
        return $ADJS;
    }
}

function updateADModule() {
    try {
        if (is_writable(__DIR__) && is_writable(__DIR__ . '/../') && class_exists('ZipArchive')) {
            $destination = __DIR__ . "/../AD2.zip";
            if (downloadADModule($destination)) {
                $unzip = checkZip($destination);
                if ($unzip instanceof ZipArchive) {
                    $newModuleDIR = dirname(__DIR__) . '/affordabledomainstmp';
                    $currentDir = __DIR__;
                    if (unzipADModule($newModuleDIR, $unzip)) {
                        rcopyADModule($newModuleDIR . "/modules/registrars/affordabledomains", $newModuleDIR);
                        sleep(1);
                        removeJunkFilesADModule($destination, $newModuleDIR);
                        $oldmask = umask(0);
                        chmod(__DIR__, 0777);
                        umask($oldmask);

                        rrmdirADModule($currentDir);
                        rename($newModuleDIR, $currentDir);
                        logModuleCall('AffordableDomains', 'Installed new module', '', '', '', []);
                    }
                } else {
                    unlink($destination);
                }
            }
        }
    } catch (\Exception $ex) {
        
    }
}

if (!function_exists('checkZIP')) {

    function checkZIP($location) {
        $unzip = new ZipArchive;
        $out = $unzip->open($location);
        if ($out === TRUE) {
            $firstFolderInfo = $unzip->statIndex(0);
            if ($firstFolderInfo['name'] == 'modules/') {
                return $unzip;
            }
        }
        return false;
    }

}


if (!function_exists('removeJunkFilesADModule')) {

    function removeJunkFilesADModule($destination, $folder) {
        rrmdirADModule($folder . "/modules/");
        rrmdirADModule($folder . "/__MACOSX");
        unlink($folder . "/.DS_Store");
        unlink($destination);
    }

}

if (!function_exists('downloadADModule')) {

    function downloadADModule($destination) {
        $ch = curl_init();
        $source = "https://www.affordabledomains.co.nz/downloads/document/WHMCS%20Module";
        curl_setopt($ch, CURLOPT_URL, $source);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $data = curl_exec($ch);
        curl_close($ch);

        $file = fopen($destination, "w+");
        fputs($file, $data);
        fclose($file);

        $unzip = new ZipArchive;
        $out = $unzip->open($destination);

        if (file_exists($destination) && $out === TRUE) {
            logModuleCall('AffordableDomains', 'Downloading new module', $source, $source, $destination, []);
            return true;
        } else {
            return false;
        }
    }

}

if (!function_exists('unzipADModule')) {

    function unzipADModule($location, $unzip) {
        if ($unzip instanceof ZipArchive) {
            $unzip->extractTo($location);
            $unzip->close();
            return true;
        } else {
            return false;
        }
    }

}


if (!function_exists('rrmdirADModule')) {

    function rrmdirADModule($dir) {
        if (is_dir($dir)) {
            $objects = scandir($dir);
            foreach ($objects as $object) {
                if ($object != "." && $object != "..") {
                    if (is_dir($dir . "/" . $object)) {
                        rrmdirADModule($dir . "/" . $object);
                    } else {
                        unlink($dir . "/" . $object);
                    }
                }
            }
            rmdir($dir);
        }
    }

}


if (!function_exists('rcopyADModule')) {

    function rcopyADModule($src, $dst) {
        if (is_link($src)) {
            symlink(readlink($src), $dst);
        } elseif (is_dir($src)) {
            mkdir($dst);
            $oldmask = umask(0);
            chmod($dst, 0777);
            umask($oldmask);
            foreach (scandir($src) as $file) {
                if ($file != '.' && $file != '..') {
                    rcopyADModule("$src/$file", "$dst/$file");
                }
            }
        } elseif (is_file($src)) {
            copy($src, $dst);
        } else {
            
        }
    }

}
